# this will evaluate the argument --with-ompss
# and do a minimal check that the header files are usuable
#
# outputs: 
#    conditional:   ENABLE_OMPSS_PLUGIN
#    ac_subst:      OMPSS_INCLUDE_PATH
AC_DEFUN([AC_AYUDAME_OMPSS], [
  AC_CONFIG_FILES([instrumentations/OmpSs/src/Makefile])
  # the following checks for --with-omps=<path>
  # and sets ENABLE_OMPSS_PLUGIN and OMPSS_INCLUDE_PATH
  AC_MSG_CHECKING(for --with-ompss argument)
  AC_ARG_WITH([ompss],
  	[AS_HELP_STRING([--with-ompss=<path>], [Path to OmpSs (i.e. Nanos++ RTL) installation directory>])],
  	[with_ompss=$withval],
  	[with_ompss="not set"]
  )
  AC_MSG_RESULT($with_ompss)
  
  # disable plugin pending checks below
  enable_ompss_plugin="no"
  # set variable for instrumenatation/OmpSs/src/Makefile.am
  AC_SUBST(OMPSS_INCLUDE_PATH, $with_ompss/include/nanox-dev)	
  # this will install OmpSs plugin into OmpSs dir 
  # (if ompss_plugin_ins_LT_LIBRARIES also set in OmpSs/src/Makefile.am
  # instead of lib_LT_LIBRARIES)
  # we prefer to install into our dir
  #AC_SUBST(ompss_plugin_insdir, $with_ompss/lib/instrumentation)
  #AC_SUBST(ompss_plugin_ins_dbgdir, $with_ompss/lib/instrumentation-debug)
  
  AS_IF([test "$with_ompss" != "not set"], [
    # test if OmpSs headers usuable; this is a hack
    AC_LANG_PUSH([C++])    # switch to C++
    CPPFLAGS_SAVE=$CPPFLAGS
    echo $CPPFLAGS_SAVE
    CPPFLAGS+=" -Ishould_not_be_here -I$with_ompss/include/nanox-dev -include"new_decl.hpp""
    AC_CHECK_HEADER([plugin.hpp], [enable_ompss_plugin="yes"], [enable_ompss_plugin="no"]) # this does not seem to work with gxx
    CPPFLAGS=$CPPFLAGS_SAVE
    # check for c++11 compiler
    #AX_CXX_COMPILE_STDCXX_11
    AC_LANG_POP([C++])
  ])
  AM_CONDITIONAL(ENABLE_OMPSS_PLUGIN, test "$enable_ompss_plugin" != "no")	
  
  # is this old or new api for getNumPEs()?
  AC_LANG_PUSH([C++])    # switch to C++
  CPPFLAGS_SAVE=$CPPFLAGS
  echo $CPPFLAGS_SAVE
  CPPFLAGS+=" -Ishould_not_be_here2 -I$with_ompss/include/nanox-dev "

  AC_COMPILE_IFELSE(
     [ AC_LANG_PROGRAM([#include <system.hpp>],
                      [System *testsys = new System(); int PEs = testsys->getNumPEs(); return 0;] )
     ], 
      [AC_DEFINE(HAVE_GETNUMPES, 1, nanos: System::getNumPEs() is present.")], 
     [AC_MSG_WARN([nanos: System::getNumPEs() is not present.])]
  )

  AC_COMPILE_IFELSE(
     [ AC_LANG_PROGRAM([#include <system.hpp>],
                      [System *testsys = new System(); int PEs = testsys->getSMPPlugin()->getNumWorkers(); return 0;] )
     ], 
      [AC_DEFINE(HAVE_GETNUMWORKERS, 1, nanos: System::getNumWorkers() is present.")], 
     [AC_MSG_WARN([nanos: System::getNumWorkers() is not present.])]
  )
  CPPFLAGS=$CPPFLAGS_SAVE
  AC_LANG_POP([C++])

])
