from distutils.core import setup, Extension
#from setuptools import setup, Extension

# for VPATH build through autotools
import os
if os.environ.has_key("SCRIPTS_DIR"):
    SCRIPTS_DIR = os.environ["SCRIPTS_DIR"] + "/"
else:
    SCRIPTS_DIR = "./"

# get version from temanejo directly
from temanejo.version import __version__

setup(
    # Application name:
    name="Temanejo",

    # Version number (initial):
    version=__version__,

    # Application author details:
    author="Steffen Brinkmann et al",
    author_email="temanejo@hlrs.de",

    # Packages
    packages=["temanejo"],

    # Include additional files into the package
    package_data={"temanejo" : ["resources/*.png"]},
    
    # Details
    url="http://www.hlrs.de/temanejo/",

    #
    license="BSD",

    description="A visual debugger for task-based parallel programming models.",

    # long_description=open("README.txt").read(),

    #
    scripts=[SCRIPTS_DIR + 'Temanejo'],
    
    # extension modules
    #ext_modules=[Extension('temanejo2.ayu_socket', ["ayu_socket.cc"])],
    #ext_modules=[Extension('temanejo2.ayu_socket', ["ayu_socket.i"],
    #                         swig_opts=['-I../include'],  # this 
    #                         include_dirs=["../include/"],  # or this 
    #                         libraries=["ayu_XXX"], library_dirs=["../lib"],
    #                         )],
)
