# COPYRIGHT
#    (C) 2014 HLRS, University of Stuttgart
#    Temanejo is published under the terms of the BSD license.

# Wrapper for differenct types of asynchronous message dialogs.
# Asynchronous means that they can be shown and be reactive even if called
# from a secondary thread such as the Communicator
#
# type is one of "ERROR", "WARNING, "INFO"
#   comment: the underlying class Gtk.MessageDialog offers also "QUESTION" and
#            "OTHER"
# message is string containing the text


import subprocess
import sys
import os

temanejo_module_base_dir = os.path.dirname(os.path.abspath(__file__))

def message_dialog_async(type, message):
    subprocess.Popen([sys.executable,
                      os.path.join(temanejo_module_base_dir,
                                   "dialog_%s.py" % type.lower()),
                      message])
